#ifndef CHECKS_PARSER_EMAIL_PARSER
#define CHECKS_PARSER_EMAIL_PARSER

#include <check/check.h>
#include <map>

class EmailParser {
    std::string get_payload_in_email(std::string &email_content);
    std::multimap<std::string, std::string> parse_email_content_types(std::string path);

    // std::vector<int> find_base64_blocks_in_email(std::string &email_content);
public:
    EmailParser();
    Check parse(std::string &email_content);
    Check parse_file(std::string path);

};

#endif // CHECKS_PARSER_EMAIL_PARSER
